diff --git a/gcc/analyzer/supergraph.cc b/gcc/analyzer/supergraph.cc
index 8592db78395..a41b6a26ff7 100644
--- a/gcc/analyzer/supergraph.cc
+++ b/gcc/analyzer/supergraph.cc
@@ -18,6 +18,7 @@ You should have received a copy of the GNU General Public License
 along with GCC; see the file COPYING3.  If not see
 <http://www.gnu.org/licenses/>.  */
 
+#define INCLUDE_DEQUE
 #include "analyzer/common.h"
 
 #include "timevar.h"
@@ -28,13 +29,18 @@ along with GCC; see the file COPYING3.  If not see
 #include "cfg.h"
 #include "digraph.h"
 #include "tree-cfg.h"
-#include "tree-dfa.h"
+//#include "tree-dfa.h"
 #include "cfganal.h"
 #include "except.h"
+#include "gcc-rich-location.h"
+#include "sbitmap.h"
+
+#include "diagnostics/file-cache.h"
 
 #include "analyzer/supergraph.h"
 #include "analyzer/analyzer-logging.h"
 #include "analyzer/region-model.h"
+#include "analyzer/exploded-graph.h"
 
 #if ENABLE_ANALYZER
 
@@ -52,25 +58,6 @@ get_ultimate_function_for_cgraph_edge (cgraph_edge *edge)
   return ultimate_node->get_fun ();
 }
 
-/* Get the cgraph_edge, but only if there's an underlying function body.  */
-
-cgraph_edge *
-supergraph_call_edge (function *fun, const gimple *stmt)
-{
-  const gcall *call = dyn_cast<const gcall *> (stmt);
-  if (!call)
-    return nullptr;
-  cgraph_edge *edge
-    = cgraph_node::get (fun->decl)->get_edge (const_cast <gimple *> (stmt));
-  if (!edge)
-    return nullptr;
-  if (!edge->callee)
-    return nullptr; /* e.g. for a function pointer.  */
-  if (!get_ultimate_function_for_cgraph_edge (edge))
-    return nullptr;
-  return edge;
-}
-
 /* class saved_uids.
 
    In order to ensure consistent results without relying on the ordering
@@ -115,108 +102,94 @@ saved_uids::restore_uids () const
     pair->first->uid = pair->second;
 }
 
+/* When building the supergraph, should STMT be handled
+   along each out-edge in the CFG, or as separate superedge
+   "within" the BB.  */
+
+static bool
+control_flow_stmt_p (const gimple &stmt)
+{
+  switch (gimple_code (&stmt))
+    {
+    case GIMPLE_COND:
+    case GIMPLE_EH_DISPATCH:
+    case GIMPLE_GOTO:
+    case GIMPLE_SWITCH:
+      return true;
+
+    case GIMPLE_ASM:
+    case GIMPLE_ASSIGN:
+    case GIMPLE_CALL:
+    case GIMPLE_DEBUG:
+    case GIMPLE_LABEL:
+    case GIMPLE_NOP:
+    case GIMPLE_PREDICT:
+    case GIMPLE_RESX:
+    case GIMPLE_RETURN:
+      return false;
+
+    /* We don't expect to see any other statement kinds in the analyzer.  */
+    default:
+      internal_error ("unexpected gimple stmt code: %qs",
+		      gimple_code_name[gimple_code (&stmt)]);
+      break;
+    }
+}
+
+
 /* supergraph's ctor.  Walk the callgraph, building supernodes for each
-   CFG basic block, splitting the basic blocks at callsites.  Join
-   together the supernodes with interprocedural and intraprocedural
-   superedges as appropriate.
+   CFG basic block, splitting the basic blocks at statements.  Join
+   together the supernodes with interprocedural superedges as appropriate.
    Assign UIDs to the gimple stmts.  */
 
-supergraph::supergraph (logger *logger)
+supergraph::supergraph (region_model_manager &mgr,
+			logger *logger)
+: m_next_snode_id (0)
 {
   auto_timevar tv (TV_ANALYZER_SUPERGRAPH);
 
   LOG_FUNC (logger);
 
+  /* For each BB, if present, the stmt that terminates it.  */
+  typedef ordered_hash_map<basic_block, gimple *> bb_to_stmt_t;
+  bb_to_stmt_t control_stmt_ending_bbs;
+
   /* First pass: make supernodes (and assign UIDs to the gimple stmts).  */
   {
     /* Sort the cgraph_nodes?  */
     cgraph_node *node;
     FOR_EACH_FUNCTION_WITH_GIMPLE_BODY (node)
-    {
-      function *fun = node->get_fun ();
-
-      /* Ensure that EDGE_DFS_BACK is correct for every CFG edge in
-	 the supergraph (by doing it per-function).  */
-      auto_cfun sentinel (fun);
-      mark_dfs_back_edges ();
+      {
+	function *fun = node->get_fun ();
 
-      const int start_idx = m_nodes.length ();
+	log_nesting_level log_sentinel (logger, "function: %qD", fun->decl);
 
-      basic_block bb;
-      FOR_ALL_BB_FN (bb, fun)
-	{
-	  /* The initial supernode for the BB gets the phi nodes (if any).  */
-	  supernode *node_for_stmts
-	    = add_node (fun, bb, nullptr, phi_nodes (bb));
-	  m_bb_to_initial_node.put (bb, node_for_stmts);
-	  for (gphi_iterator gpi = gsi_start_phis (bb); !gsi_end_p (gpi);
-	       gsi_next (&gpi))
-	    {
-	      gimple *stmt = gsi_stmt (gpi);
-	      m_stmt_to_node_t.put (stmt, node_for_stmts);
-	      m_stmt_uids.make_uid_unique (stmt);
-	    }
+	/* Ensure that EDGE_DFS_BACK is correct for every CFG edge in
+	   the supergraph (by doing it per-function).  */
+	auto_cfun cfun_sentinel (fun);
+	mark_dfs_back_edges ();
 
-	  /* Append statements from BB to the current supernode, splitting
-	     them into a new supernode at each call site; such call statements
-	     appear in both supernodes (representing call and return).  */
-	  gimple_stmt_iterator gsi;
-	  for (gsi = gsi_start_bb (bb); !gsi_end_p (gsi); gsi_next (&gsi))
-	    {
-	      gimple *stmt = gsi_stmt (gsi);
-	      /* Discard debug stmts here, so we don't have to check for
-		 them anywhere within the analyzer.  */
-	      if (is_gimple_debug (stmt))
-		continue;
-	      node_for_stmts->m_stmts.safe_push (stmt);
-	      m_stmt_to_node_t.put (stmt, node_for_stmts);
-	      m_stmt_uids.make_uid_unique (stmt);
-	      if (cgraph_edge *edge = supergraph_call_edge (fun, stmt))
-		{
-		  m_cgraph_edge_to_caller_prev_node.put(edge, node_for_stmts);
-		  node_for_stmts = add_node (fun, bb, as_a <gcall *> (stmt),
-					     nullptr);
-		  m_cgraph_edge_to_caller_next_node.put (edge, node_for_stmts);
-		}
-	       else
-	        {
-	          // maybe call is via a function pointer
-	          if (gcall *call = dyn_cast<gcall *> (stmt))
-	          {
-	            cgraph_edge *edge
-		      = cgraph_node::get (fun->decl)->get_edge (stmt);
-	            if (!edge || !edge->callee)
-	            {
-	              supernode *old_node_for_stmts = node_for_stmts;
-	              node_for_stmts = add_node (fun, bb, call, nullptr);
-
-	              superedge *sedge
-	                = new callgraph_superedge (old_node_for_stmts,
-	                  			   node_for_stmts,
-	                  			   SUPEREDGE_INTRAPROCEDURAL_CALL,
-	                  			   nullptr);
-	              add_edge (sedge);
-	            }
-	          }
-	        }
-	    }
+	const int start_id = m_nodes.length ();
 
-	  m_bb_to_final_node.put (bb, node_for_stmts);
-	}
+	basic_block bb;
+	FOR_ALL_BB_FN (bb, fun)
+	  if (gimple *final_control_stmt
+		= populate_for_basic_block (bb, fun, logger))
+	    control_stmt_ending_bbs.put (bb, final_control_stmt);
 
-      const unsigned num_snodes = m_nodes.length () - start_idx;
-      m_function_to_num_snodes.put (fun, num_snodes);
+	const unsigned num_snodes = m_nodes.length () - start_id;
+	m_function_to_num_snodes.put (fun, num_snodes);
 
-      if (logger)
-	{
-	  const int end_idx = m_nodes.length () - 1;
-	  logger->log ("SN: %i...%i: function %qD",
-		       start_idx, end_idx, fun->decl);
-	}
-    }
+	if (logger)
+	  {
+	    const int end_id = m_nodes.length () - 1;
+	    logger->log ("SN: %i...%i: function %qD",
+			 start_id, end_id, fun->decl);
+	  }
+      }
   }
 
-  /* Second pass: make superedges.  */
+  /* Second pass: make superedges between basic blocks.  */
   {
     /* Make superedges for CFG edges.  */
     for (bb_to_node_t::iterator iter = m_bb_to_final_node.begin ();
@@ -226,6 +199,10 @@ supergraph::supergraph (logger *logger)
 	basic_block bb = (*iter).first;
 	supernode *src_supernode = (*iter).second;
 
+	gimple *control_stmt_ending_bb = nullptr;
+	if (auto control_stmt_iter = control_stmt_ending_bbs.get (bb))
+	  control_stmt_ending_bb = *control_stmt_iter;
+
 	::edge cfg_edge;
 	int idx;
 	if (bb->succs)
@@ -234,80 +211,154 @@ supergraph::supergraph (logger *logger)
 	      basic_block dest_cfg_block = cfg_edge->dest;
 	      supernode *dest_supernode
 		= *m_bb_to_initial_node.get (dest_cfg_block);
-	      cfg_superedge *cfg_sedge
-		= add_cfg_edge (src_supernode, dest_supernode, cfg_edge);
-	      m_cfg_edge_to_cfg_superedge.put (cfg_edge, cfg_sedge);
+	      add_sedges_for_cfg_edge (src_supernode,
+				       dest_supernode,
+				       cfg_edge,
+				       control_stmt_ending_bb,
+				       mgr,
+				       logger);
 	    }
       }
+  }
+}
+
+/* Create a run of supernodes and superedges for the BB within FUN
+   expressing all of the stmts apart from the final control flow stmt (if any).
+   Return the control stmt that ends this bb, if any.  */
 
-    /* Make interprocedural superedges for calls.  */
+gimple *
+supergraph::populate_for_basic_block (basic_block bb,
+				      function *fun,
+				      logger *logger)
+{
+  log_nesting_level sentinel (logger, "bb %i", bb->index);
+
+  supernode *initial_snode_in_bb = add_node (fun, bb, logger);
+  m_bb_to_initial_node.put (bb, initial_snode_in_bb);
+
+  if (bb->index == ENTRY_BLOCK)
+    /* Use the decl's location, rather than fun->function_start_locus,
+       which leads to more readable output.  */
+    initial_snode_in_bb->m_loc = DECL_SOURCE_LOCATION (fun->decl);
+  else if (bb->index == EXIT_BLOCK)
+    initial_snode_in_bb->m_loc = fun->function_end_locus;
+  else if (gsi_end_p (gsi_start_bb (bb)))
     {
-      for (cgraph_edge_to_node_t::iterator iter
-	     = m_cgraph_edge_to_caller_prev_node.begin ();
-	   iter != m_cgraph_edge_to_caller_prev_node.end ();
-	   ++iter)
+      /* BB has no stmts, and isn't the ENTRY or EXIT node.
+	 Try to find a source location for it.  */
+      if (bb->succs->length () == 1)
 	{
-	  cgraph_edge *edge = (*iter).first;
-	  supernode *caller_prev_supernode = (*iter).second;
-	  function* callee_fn = get_ultimate_function_for_cgraph_edge (edge);
-	  if (!callee_fn || !callee_fn->cfg)
-	    continue;
-	  basic_block callee_cfg_block = ENTRY_BLOCK_PTR_FOR_FN (callee_fn);
-	  supernode *callee_supernode
-	    = *m_bb_to_initial_node.get (callee_cfg_block);
-	  call_superedge *sedge
-	    = add_call_superedge (caller_prev_supernode,
-				  callee_supernode,
-				  edge);
-	  m_cgraph_edge_to_call_superedge.put (edge, sedge);
+	  auto outedge = (*bb->succs)[0];
+	  if (useful_location_p (outedge->goto_locus))
+	    {
+	      /* We have an empty basic block with one out-edge,
+		 perhaps part of an empty infinite loop.  */
+	      if (logger)
+		logger->log ("using location 0x%lx from outedge",
+			     outedge->goto_locus);
+	      initial_snode_in_bb->m_loc = outedge->goto_locus;
+	    }
 	}
     }
 
-    /* Make interprocedural superedges for returns.  */
+  initial_snode_in_bb->m_state_merger_node = true;
+
+  gimple *final_control_flow_stmt = nullptr;
+
+  /* Create a run of supernodes for the stmts in BB,
+     connected by stmt_superedge.  */
+  gimple_stmt_iterator gsi;
+  supernode *prev_snode_in_bb = initial_snode_in_bb;
+  for (gsi = gsi_start_bb (bb); !gsi_end_p (gsi); gsi_next (&gsi))
     {
-      for (cgraph_edge_to_node_t::iterator iter
-	     = m_cgraph_edge_to_caller_next_node.begin ();
-	   iter != m_cgraph_edge_to_caller_next_node.end ();
-	   ++iter)
+      gimple *next_stmt = gsi_stmt (gsi);
+
+      if (logger)
+	{
+	  logger->start_log_line ();
+	  logger->log_partial ("next_stmt: ");
+	  pp_gimple_stmt_1 (logger->get_printer (), next_stmt,
+			    0, (dump_flags_t)0);
+	  logger->end_log_line ();
+	}
+      prev_snode_in_bb->m_loc = get_stmt_location (next_stmt, fun);
+      prev_snode_in_bb->m_stmt_loc = next_stmt->location;
+      m_node_for_stmt.insert ({next_stmt, prev_snode_in_bb});
+
+      m_stmt_uids.make_uid_unique (next_stmt);
+
+      if (auto glabel_ = dyn_cast<const glabel *>(next_stmt))
 	{
-	  cgraph_edge *edge = (*iter).first;
-	  supernode *caller_next_supernode = (*iter).second;
-	  function* callee_fn = get_ultimate_function_for_cgraph_edge (edge);
-	  if (!callee_fn || !callee_fn->cfg)
+	  /* Associate the GIMPLE_LABEL with its snode.  */
+	  prev_snode_in_bb->m_label = gimple_label_label (glabel_);
+
+	  /* Only create an snode for the label if it has location
+	     information.  */
+	  if (glabel_->location == UNKNOWN_LOCATION)
 	    continue;
-	  basic_block callee_cfg_block = EXIT_BLOCK_PTR_FOR_FN (callee_fn);
-	  supernode *callee_supernode
-	    = *m_bb_to_initial_node.get (callee_cfg_block);
-	  return_superedge *sedge
-	    = add_return_superedge (callee_supernode,
-				    caller_next_supernode,
-				    edge);
-	  m_cgraph_edge_to_return_superedge.put (edge, sedge);
 	}
-    }
 
-    /* Make intraprocedural superedges linking the two halves of a call.  */
-    {
-      for (cgraph_edge_to_node_t::iterator iter
-	     = m_cgraph_edge_to_caller_prev_node.begin ();
-	   iter != m_cgraph_edge_to_caller_prev_node.end ();
-	   ++iter)
+      // handle control flow stmts on the edges
+      if (control_flow_stmt_p (*next_stmt))
 	{
-	  cgraph_edge *edge = (*iter).first;
-	  supernode *caller_prev_supernode = (*iter).second;
-	  supernode *caller_next_supernode
-	    = *m_cgraph_edge_to_caller_next_node.get (edge);
+	  final_control_flow_stmt = next_stmt;
+	  break;
+	}
+
+      supernode *snode_after_next_stmt = add_node (fun, bb, logger);
+      if (prev_snode_in_bb)
+	{
+	  std::unique_ptr<operation> op;
+	  switch (gimple_code (next_stmt))
+	    {
+	    default:
+	      gcc_unreachable ();
+	      break;
+	    case GIMPLE_ASM:
+	      op = std::make_unique<gasm_op>
+		(*as_a <const gasm *> (next_stmt));
+	      break;
+	    case GIMPLE_ASSIGN:
+	      op = std::make_unique<gassign_op>
+		(*as_a <const gassign *> (next_stmt));
+	      break;
+	    case GIMPLE_CALL:
+	      op = call_and_return_op::make
+		(*as_a <const gcall *> (next_stmt));
+	      break;
+	    case GIMPLE_PREDICT:
+	      op = std::make_unique<predict_op> (*next_stmt);
+	      break;
+	    case GIMPLE_RESX:
+	      op = std::make_unique<resx_op>
+		(*as_a <const gresx *> (next_stmt));
+	      break;
+	    case GIMPLE_RETURN:
+	      op = std::make_unique<greturn_op>
+		(*as_a <const greturn *> (next_stmt));
+	      break;
+
+	    case GIMPLE_DEBUG:
+	    case GIMPLE_LABEL:
+	    case GIMPLE_NOP:
+	      /* Treat all of these as no-ops within analyzer; though
+		 perhaps we care about their locations.  */
+	      break;
+	    }
+
 	  superedge *sedge
-	    = new callgraph_superedge (caller_prev_supernode,
-				       caller_next_supernode,
-				       SUPEREDGE_INTRAPROCEDURAL_CALL,
-				       edge);
+	    = new superedge (prev_snode_in_bb,
+			     snode_after_next_stmt,
+			     std::move (op),
+			     nullptr);
 	  add_edge (sedge);
-	  m_cgraph_edge_to_intraproc_superedge.put (edge, sedge);
 	}
-
+      prev_snode_in_bb = snode_after_next_stmt;
     }
-  }
+
+  m_bb_to_final_node.put (bb, prev_snode_in_bb);
+
+  return final_control_flow_stmt;
 }
 
 /* supergraph's dtor.  Reset stmt uids.  */
@@ -347,6 +398,8 @@ supergraph::dump_dot_to_pp (pretty_printer *pp,
     {
       function *fun = node->get_fun ();
       gcc_assert (fun);
+      auto_cfun sentinel (fun);
+
       const char *funcname = function_name (fun);
       gv.println ("subgraph \"cluster_%s\" {",
 		  funcname);
@@ -357,45 +410,14 @@ supergraph::dump_dot_to_pp (pretty_printer *pp,
 		  " label=\"%s\";\n"),
 		 funcname);
 
-      /* Break out the nodes into clusters by BB from original CFG.  */
-      {
-	basic_block bb;
-	FOR_ALL_BB_FN (bb, fun)
-	  {
-	    if (dump_args.m_flags & SUPERGRAPH_DOT_SHOW_BBS)
-	      {
-		gv.println ("subgraph \"cluster_%s_bb_%i\" {",
-			    funcname, bb->index);
-		gv.indent ();
-		pp_printf (pp,
-			   ("style=\"dashed\";"
-			    " color=\"black\";"
-			    " label=\"bb: %i\";\n"),
-			   bb->index);
-	      }
-
-	    // TODO: maybe keep an index per-function/per-bb to speed this up???
-	    int i;
-	    supernode *n;
-	    FOR_EACH_VEC_ELT (m_nodes, i, n)
-	      if (n->m_fun == fun && n->m_bb == bb)
-		n->dump_dot (&gv, dump_args);
-
-	    if (dump_args.m_flags & SUPERGRAPH_DOT_SHOW_BBS)
-	      {
-		/* Terminate per-bb "subgraph" */
-		gv.outdent ();
-		gv.println ("}");
-	      }
-	  }
-      }
-
-      /* Add an invisible edge from ENTRY to EXIT, to improve the graph layout.  */
-      pp_string (pp, "\t");
-      get_node_for_function_entry (*fun)->dump_dot_id (pp);
-      pp_string (pp, ":s -> ");
-      get_node_for_function_exit (*fun)->dump_dot_id (pp);
-      pp_string (pp, ":n [style=\"invis\",constraint=true];\n");
+      if (loops_for_fn (fun))
+	dump_dot_to_gv_for_loop (gv, dump_args, get_loop (fun, 0), fun);
+      else
+	{
+	  basic_block bb;
+	  FOR_ALL_BB_FN (bb, fun)
+	    dump_dot_to_gv_for_bb (gv, dump_args, bb, fun);
+	}
 
       /* Terminate per-function "subgraph" */
       gv.outdent ();
@@ -409,11 +431,108 @@ supergraph::dump_dot_to_pp (pretty_printer *pp,
   FOR_EACH_VEC_ELT (m_edges, i, e)
     e->dump_dot (&gv, dump_args);
 
+  if (dump_args.m_node_annotator)
+    dump_args.m_node_annotator->add_extra_objects (&gv);
+
   /* Terminate "digraph" */
   gv.outdent ();
   gv.println ("}");
 }
 
+/* Recursively dump all the snodes within LOOP and the loops
+   within it.  */
+
+void
+supergraph::dump_dot_to_gv_for_loop (graphviz_out &gv,
+				     const dump_args_t &dump_args,
+				     class loop *loop,
+				     function *fun) const
+{
+  pretty_printer *pp = gv.get_pp ();
+
+  basic_block *body;
+  unsigned int i;
+  // Adapted from graph.cc:draw_cfg_nodes_for_loop
+  const char *fillcolors[3] = { "grey88", "grey77", "grey66" };
+
+  if (loop->header != NULL
+      && loop->latch != EXIT_BLOCK_PTR_FOR_FN (cfun))
+    pp_printf (pp,
+	       "\tsubgraph cluster_%d_%d {\n"
+	       "\tstyle=\"filled\";\n"
+	       "\tcolor=\"darkgreen\";\n"
+	       "\tfillcolor=\"%s\";\n"
+	       "\tlabel=\"loop %d\";\n"
+	       "\tlabeljust=l;\n"
+	       "\tpenwidth=2;\n",
+	       fun->funcdef_no, loop->num,
+	       fillcolors[(loop_depth (loop) - 1) % 3],
+	       loop->num);
+
+  // Recurse
+  for (class loop *inner = loop->inner; inner; inner = inner->next)
+    dump_dot_to_gv_for_loop (gv, dump_args, inner, fun);
+
+  if (loop->header == NULL)
+    return;
+
+  if (loop->latch == EXIT_BLOCK_PTR_FOR_FN (cfun))
+    body = get_loop_body (loop);
+  else
+    body = get_loop_body_in_bfs_order (loop);
+
+  for (i = 0; i < loop->num_nodes; i++)
+    {
+      basic_block bb = body[i];
+      if (bb->loop_father == loop)
+	dump_dot_to_gv_for_bb (gv, dump_args, bb, fun);
+    }
+
+  free (body);
+
+  if (loop->latch != EXIT_BLOCK_PTR_FOR_FN (cfun))
+    pp_printf (pp, "\t}\n");
+}
+
+/* Dump all the snodes from BB.  */
+
+void
+supergraph::dump_dot_to_gv_for_bb (graphviz_out &gv,
+				   const dump_args_t &dump_args,
+				   basic_block bb,
+				   function *fun) const
+{
+  pretty_printer *pp = gv.get_pp ();
+
+  if (dump_args.m_flags & SUPERGRAPH_DOT_SHOW_BBS)
+    {
+      const char *funcname = function_name (fun);
+      gv.println ("subgraph \"cluster_%s_bb_%i\" {",
+		  funcname, bb->index);
+      gv.indent ();
+      pp_printf (pp,
+		 ("style=\"dashed\";"
+		  " color=\"black\";"
+		  " label=\"bb: %i\";\n"),
+		 bb->index);
+    }
+
+  // TODO: maybe keep an index per-function/per-bb to speed this up???
+  int i;
+  supernode *n;
+  FOR_EACH_VEC_ELT (m_nodes, i, n)
+    if (n->m_fun == fun && n->m_bb == bb)
+      n->dump_dot (&gv, dump_args);
+
+  if (dump_args.m_flags & SUPERGRAPH_DOT_SHOW_BBS)
+    {
+      /* Terminate per-bb "subgraph" */
+      gv.outdent ();
+      gv.println ("}");
+    }
+}
+
+
 /* Dump this graph in .dot format to FP, using DUMP_ARGS.  */
 
 void
@@ -472,72 +591,185 @@ supergraph::to_json () const
   return sgraph_obj;
 }
 
-/* Create a supernode for BB within FUN and add it to this supergraph.
-
-   If RETURNING_CALL is non-NULL, the supernode represents the resumption
-   of the basic block after returning from that call.
-
-   If PHI_NODES is non-NULL, this is the initial supernode for the basic
-   block, and is responsible for any handling of the phi nodes.  */
+/* Create a supernode within BB within FUN and add it to this supergraph.  */
 
 supernode *
-supergraph::add_node (function *fun, basic_block bb, gcall *returning_call,
-		      gimple_seq phi_nodes)
+supergraph::add_node (function *fun, basic_block bb, logger *logger)
 {
-  supernode *n = new supernode (fun, bb, returning_call, phi_nodes,
-				m_nodes.length ());
+  supernode *n = new supernode (fun, bb, m_next_snode_id++);
+  m_snode_by_id.push_back (n);
   m_nodes.safe_push (n);
+  if (logger)
+    logger->log ("created SN %i", n->m_id);
   return n;
 }
 
-/* Create a new cfg_superedge from SRC to DEST for the underlying CFG edge E,
-   adding it to this supergraph.
-
-   If the edge is for a switch or eh_dispatch statement, create a
-   switch_cfg_superedge or eh_dispatch_cfg_superedge subclass,
-   respectively  */
-
-cfg_superedge *
-supergraph::add_cfg_edge (supernode *src, supernode *dest, ::edge e)
+void
+supergraph::delete_nodes (const std::set<supernode *> &snodes_to_delete)
 {
-  /* Special-case switch and eh_dispatch edges.  */
-  gimple *stmt = src->get_last_stmt ();
-  std::unique_ptr<cfg_superedge> new_edge;
-  if (stmt && stmt->code == GIMPLE_SWITCH)
-    new_edge = std::make_unique<switch_cfg_superedge> (src, dest, e);
-  else if (stmt && stmt->code == GIMPLE_EH_DISPATCH)
-    new_edge = eh_dispatch_cfg_superedge::make (src, dest, e,
-						as_a <geh_dispatch *> (stmt));
-  else
-    new_edge = std::make_unique<cfg_superedge> (src, dest, e);
-  add_edge (new_edge.get ());
-  return new_edge.release ();
+  /* Remove nodes from m_nodes.  */
+  unsigned read_index, write_index;
+  supernode **elem_ptr;
+  VEC_ORDERED_REMOVE_IF
+    (m_nodes, read_index, write_index, elem_ptr,
+     snodes_to_delete.find (*elem_ptr) != snodes_to_delete.end ()
+     );
+
+  /* Remove nodes from m_snode_by_id, and delete them.  */
+  for (auto iter : snodes_to_delete)
+    {
+      gcc_assert (iter->m_preds.length () == 0);
+      gcc_assert (iter->m_succs.length () == 0);
+      m_snode_by_id[iter->m_id] = nullptr;
+      delete iter;
+    }
 }
 
-/* Create and add a call_superedge representing an interprocedural call
-   from SRC to DEST, using CEDGE.  */
+/* Create a chain of nodes and edges in this supergraph from SRC to DEST
+   to handle CFG_EDGE in the underlying CFG:
+
+    +---+
+    |SRC|
+    +---+
+      |
+      | optional edge for ctrlflow_stmt (if CTRLFLOW_STMT is non-null)
+      | (e.g. checking conditions on a GIMPLE_COND)
+      |
+      V
+   +------+
+   |(node)|
+   +------+
+      |
+      | optional edge for any phi nodes in the destination basic block
+      |
+      V
+   +------+
+   |(node)|
+   +------+
+      |
+      | optional edge for state merging at CFG join points
+      |
+      V
+   +----+
+   |DEST|
+   +----+
+
+   adding nodes where necessary between the edges, and adding a no-op edge
+   for the case where there is no CTRLFLOW_STMT, phi nodes, or
+   state merging.  */
 
-call_superedge *
-supergraph::add_call_superedge (supernode *src, supernode *dest,
-				cgraph_edge *cedge)
+void
+supergraph::add_sedges_for_cfg_edge (supernode *src,
+				     supernode *dest,
+				     ::edge cfg_edge,
+				     gimple *ctrlflow_stmt,
+				     region_model_manager &mgr,
+				     logger *logger)
 {
-  call_superedge *new_edge = new call_superedge (src, dest, cedge);
-  add_edge (new_edge);
-  return new_edge;
-}
+  log_nesting_level sentinel (logger,
+			      "edge: bb %i -> bb %i",
+			      cfg_edge->src->index,
+			      cfg_edge->dest->index);
+  std::unique_ptr<operation> ctrlflow_op;
+  if (ctrlflow_stmt)
+    switch (gimple_code (ctrlflow_stmt))
+      {
+      default:
+	gcc_unreachable ();
+	break;
+      case GIMPLE_COND:
+	ctrlflow_op = std::make_unique<gcond_edge_op>
+	  (cfg_edge,
+	   *as_a <gcond *> (ctrlflow_stmt));
+	break;
+      case GIMPLE_EH_DISPATCH:
+	ctrlflow_op
+	  = eh_dispatch_edge_op::make (src, dest,
+				       cfg_edge,
+				       *as_a <geh_dispatch *> (ctrlflow_stmt));
+	break;
+      case GIMPLE_GOTO:
+	{
+	  ctrlflow_op = std::make_unique<ggoto_edge_op>
+	    (cfg_edge,
+	     *as_a <ggoto *> (ctrlflow_stmt),
+	     dest->m_label);
+	}
+	break;
+      case GIMPLE_SWITCH:
+	ctrlflow_op = std::make_unique<switch_case_op>
+	  (*src->get_function (),
+	   cfg_edge,
+	   *as_a <gswitch *> (ctrlflow_stmt),
+	   *mgr.get_range_manager ());
+	break;
+      }
+  else
+    {
+      if (cfg_edge->flags & EDGE_ABNORMAL)
+	/* Don't create superedges for such CFG edges (though
+	   computed gotos are handled by the GIMPLE_GOTO clause above).  */
+	return;
+    }
 
-/* Create and add a return_superedge representing returning from an
-   interprocedural call, returning from SRC to DEST, using CEDGE.  */
+  /* Determine a location to use for any snodes within the CFG edge.  */
+  location_t dest_loc = dest->m_loc;
+  if (useful_location_p (cfg_edge->goto_locus))
+    dest_loc = cfg_edge->goto_locus;
+
+  /* If the dest is a control flow join point, then for each CFG in-edge
+     add an extra snode/sedge before DEST and route to it.
+     We hope this will help state-merging keep the
+     different in-edges separately.  */
+  if (cfg_edge->dest->preds->length () > 1
+      && cfg_edge->dest->index != EXIT_BLOCK)
+    {
+      auto extra_snode = add_node (src->get_function (),
+				   cfg_edge->dest,
+				   logger);
+      extra_snode->m_loc = dest_loc;
+      extra_snode->m_preserve_p = true;
+      extra_snode->m_state_merger_node = true;
+      add_edge (new superedge (extra_snode, dest, nullptr, nullptr));
+      dest = extra_snode;
+    }
 
-return_superedge *
-supergraph::add_return_superedge (supernode *src, supernode *dest,
-				  cgraph_edge *cedge)
-{
-  return_superedge *new_edge = new return_superedge (src, dest, cedge);
-  add_edge (new_edge);
-  return new_edge;
+  std::unique_ptr<operation> phi_op;
+  if (phi_nodes (cfg_edge->dest))
+    phi_op = phis_for_edge_op::maybe_make (cfg_edge);
+  if (phi_op)
+    {
+      superedge *edge_for_phis_op;
+      if (ctrlflow_op)
+	{
+	  /* We have two ops; add an edge for each:
+	     SRC --{ctrlflow_op}--> before_phi_nodes --{phi_op}--> DEST.  */
+	  supernode *before_phi_nodes
+	    = add_node (src->get_function (), cfg_edge->src, logger); // FIXME
+	  before_phi_nodes->m_loc = dest_loc;
+	  add_edge (new superedge (src, before_phi_nodes,
+				   std::move (ctrlflow_op),
+				   cfg_edge));
+	  edge_for_phis_op = new superedge (before_phi_nodes, dest,
+					    std::move (phi_op),
+					    cfg_edge);
+	}
+      else
+	/* We just have a phi_op; add: SRC --{phi_op}--> DEST.  */
+	edge_for_phis_op
+	  = new superedge (src, dest, std::move (phi_op), cfg_edge);
+      add_edge (edge_for_phis_op);
+      m_edges_for_phis.insert ({cfg_edge, edge_for_phis_op});
+    }
+  else
+    /* We don't have a phi op, create this edge:
+       SRC --{ctrlflow_op}--> DEST
+       where ctrlflow_op might be nullptr (for a no-op edge).  */
+    add_edge (new superedge (src, dest, std::move (ctrlflow_op), cfg_edge));
 }
 
+// class supernode : public dnode<supergraph_traits>
+
 /* Implementation of dnode::dump_dot vfunc for supernodes.
 
    Write a cluster for the node, and within it a .dot node showing
